﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using WcfContrib.Client;
using System.ServiceModel;

namespace WcfContrib.Test.Client
{
    public class MyClientChannel<T> : MyClientChannel<MyClientChannel<T>, T>
        where T : class
    {
        public MyClientChannel() { }

        public MyClientChannel(ChannelManageOptions manageOptions)
            : base(manageOptions) { }

        public MyClientChannel(ChannelFactory channelFactory)
            : base(channelFactory) { }

        public MyClientChannel(ChannelFactory channelFactory, ChannelManageOptions manageOptions)
            : base(channelFactory, manageOptions) { }
    }

    public class MyClientChannel<TInstance, T> : ClientChannel<TInstance, T>
        where T : class
        where TInstance : ClientChannel<T>, new()
    {
        private ChannelFactory _factory;

        public MyClientChannel()
        {
            OnInitialize(null);
        }

        public MyClientChannel(ChannelManageOptions manageOptions)
            : base(manageOptions)
        {
            OnInitialize(null);
        }

        public MyClientChannel(ChannelFactory channelFactory)
        {
            OnInitialize(channelFactory);
        }

        public MyClientChannel(ChannelFactory channelFactory, ChannelManageOptions manageOptions)
            : base(manageOptions)
        {
            OnInitialize(channelFactory);
        }

        void OnInitialize(ChannelFactory channelFactory)
        {
            //You can decide to disable factory caching if you provide it with a factory which is cached already
            //CacheChannelFactory = (channelFactory != null);

            _factory = channelFactory;
        }

        protected override ChannelFactory CreateChannelFactoryCore(string endpointName)
        {
            if (_factory == null)
            {
                //If the factory wasn't provided from outside, just call the base which tries to load it from the configuration
                _factory = base.CreateChannelFactoryCore(endpointName);
            }

            return _factory;
        }
    }
}
