﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ServiceModel;
using System.Runtime.Serialization;
using WcfContrib.Extensions.Caching;

namespace Contracts
{
    [ServiceContract]
    //[OutputCacheBehavior(OutputCachePolicy.Absolute, 3000, IgnoreDefaultValue = true)]
    //[OutputCacheBehavior(OutputCachePolicy.Sliding, 3000)]
    interface IService
    {
        [OperationContract]
        void Do(Foo foo);

        [OperationContract(AsyncPattern = true)]
        IAsyncResult BeginDo(Foo foo, AsyncCallback callback, object asyncState);
        void EndDo(IAsyncResult result);

        [OperationContract]
        Foo GetFoo1();

        [OperationContract(AsyncPattern = true)]
        IAsyncResult BeginGetFoo1(AsyncCallback callback, object asyncState);
        Foo EndGetFoo1(IAsyncResult result);

        [OperationContract]
        Foo GetFoo2(int id);

        [OperationContract(AsyncPattern = true)]
        IAsyncResult BeginGetFoo2(int id, AsyncCallback callback, object asyncState);
        Foo EndGetFoo2(IAsyncResult result);

        [OperationContract]
        Foo GetFoo3(int[] id);

        [OperationContract]
        Foo GetFoo4(Foo[] id);

        [OperationContract]
        Foo GetFoo5(Foo foo);
    }

    [DataContract]
    public class Foo
    {
        [DataMember]
        public int Id { get; set; }

        [DataMember]
        public string Name { get; set; }

        public override string ToString()
        {
            return string.Format("Foo Id - {0}", Id);
        }

        public override bool Equals(object obj)
        {
            return Id.Equals(((Foo)obj).Id);
        }

        public override int GetHashCode()
        {
            return Id.GetHashCode();
        }
    }
}
