﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Contracts;
using System.ServiceModel;
using WcfContrib.Errors;
using WcfContrib.Extensions.Context;
using WcfContrib.Handlers;
using WcfContrib.Extensions;

namespace WcfContrib.Test.Services
{
    [ServiceBehavior(ConfigurationName = "MyService", InstanceContextMode = InstanceContextMode.PerSession)]
    [ServiceExtensionsSelector]
    class Service : ServiceBase
    {
        
    }

    [ServiceBehavior(ConfigurationName = "MyService2", InstanceContextMode = InstanceContextMode.PerCall)]
    [ServiceExtensionsSelector]
    class Service2 : ServiceBase
    {

    }

    class ServiceBase : IService
    {
        #region IService Members

        [System.Diagnostics.DebuggerStepThrough]
        public void Do(Foo foo)
        {
            Helpers.WriteLine(ConsoleColor.Cyan, "Service: Do()");

            //throw new Exception();

            ShowContextExtension();
        }

        void ShowContextExtension()
        {
            ActivationContextExtension contextExtension = ActivationContextExtension.Current;

            bool hasItem = contextExtension.SessionItems.ContainsKey("1");
            Helpers.WriteLine(ConsoleColor.Yellow, "Has session item: {0}", hasItem);

            if (!hasItem)
            {
                contextExtension.SessionItems.Add("1", "2");
            }
        }

        #endregion

        #region IService Members

        static int idCounter;
        public Foo GetFoo1()
        {
            //throw new InvalidCastException("aa");
            Helpers.WriteLine(ConsoleColor.Cyan, "Service: GetFoo1()");
            idCounter++;

            //return null;
            return new Foo { Id = idCounter, Name = "Foo 1" };
        }

        public Foo GetFoo2(int id)
        {
            //throw new InvalidCastException("aa");
            Helpers.WriteLine(ConsoleColor.Cyan, "Service: GetFoo2(int)");

            return new Foo { Id = id, Name = "Foo 2" };
        }

        public Foo GetFoo3(int[] id)
        {
            Helpers.WriteLine(ConsoleColor.Cyan, "Service: GetFoo3(int[])");

            return new Foo { Id = 3, Name = "Foo 3" };
        }

        public Foo GetFoo4(Foo[] id)
        {
            Helpers.WriteLine(ConsoleColor.Cyan, "Service: GetFoo4(Foo[])");

            return new Foo { Id = 4, Name = "Foo 4" };
        }

        public Foo GetFoo5(Foo foo)
        {
            Helpers.WriteLine(ConsoleColor.Cyan, "Service: GetFoo4(Foo)");

            foo.Id++;
            return foo;
        }

        #endregion
    }
}
