﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ServiceModel;

namespace WcfContrib.Client.Behaviors
{
    /// <summary>
    /// Represents an interface for participating in the initialization of communication channels
    /// </summary>
    public interface IClientChannelHandlerBehavior
    {
        /// <summary>
        /// Occurs when the channel factory is created.
        /// </summary>
        /// <param name="clientChannel">The client channel.</param>
        /// <param name="factory">The channel factory.</param>
        void ChannelFactoryCreated(ClientChannel clientChannel, ChannelFactory factory);

        /// <summary>
        /// Occurs when the communication channel is created.
        /// </summary>
        /// <param name="clientChannel">The client channel.</param>
        /// <param name="channel">The communication channel.</param>
        void ChannelCreated(ClientChannel clientChannel, ICommunicationObject channel);
    }
}
