﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Configuration;

namespace WcfContrib.Configuration
{
    /// <summary>
    /// Represents an extensions configuration element
    /// </summary>
    public class ExtensionsConfigurationElement : ConfigurationElement
    {
        /// <summary>
        /// Gets or sets the output cache extension element.
        /// </summary>
        /// <value>The output cache.</value>
        [ConfigurationProperty("outputCache")]
        public OutputCacheExtensionConfigurationElement OutputCache
        {
            get { return (OutputCacheExtensionConfigurationElement)base["outputCache"]; }
            set { base["outputCache"] = value; }
        }

        /// <summary>
        /// Gets or sets the log trace extension element.
        /// </summary>
        /// <value>The log trace.</value>
        [ConfigurationProperty("logTrace")]
        public LogTraceExtensionConfigurationElement LogTrace
        {
            get { return (LogTraceExtensionConfigurationElement)base["logTrace"]; }
            set { base["logTrace"] = value; }
        }
    }
}
