﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Configuration;

namespace WcfContrib.Configuration
{
    /// <summary>
    /// Represents a services configuration element
    /// </summary>
    public class ServicesConfigurationElement : ConfigurationElement
    {
        /// <summary>
        /// Gets or sets a value indicating whether to apply endpoints and bindings boosting.
        /// </summary>
        /// <value><c>true</c> if to apply endpoints and bindings boosting; otherwise, <c>false</c>.</value>
        [ConfigurationProperty("applyBoosting", DefaultValue = false)]
        public bool ApplyBoosting
        {
            get { return (bool)base["applyBoosting"]; }
            set { base["applyBoosting"] = value; }
        }
    }
}
