﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace WcfContrib.Extensions.Caching
{
    /// <summary>
    /// Represents output cache policies
    /// </summary>
    public enum OutputCachePolicy
    {
        /// <summary>
        /// Absolute-based interval, counting from the time the item was inserted to the cache
        /// </summary>
        Absolute,
        /// <summary>
        /// Sliding-based interval, counting from the time the item was last retrieved from the cache
        /// </summary>
        Sliding,
        /// <summary>
        /// Indefinite time, stays alive forever, never gets clear
        /// </summary>
        Indefinite
    }
}
