﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Diagnostics;
using System.ServiceModel.Channels;
using System.ServiceModel.Description;
using System.ServiceModel;

namespace WcfContrib.Extensions
{
    /// <summary>
    /// Represents the level of parameter detail.
    /// </summary>
    public enum ParameterDetail
    {
        /// <summary>
        /// No detail
        /// </summary>
        None,
        /// <summary>
        /// Shows whether the parameters are instantiated or not
        /// </summary>
        Existence,
        /// <summary>
        /// Serializes the parameters only if the reply is a fault message
        /// </summary>
        SerializeOnFaultReply,
        /// <summary>
        /// Serializes the parameters
        /// </summary>
        Serialize
    }
}
