﻿using System;
using System.Collections.Generic;
using System.Text;

namespace WcfContrib.Handlers
{
    /// <summary>
    /// Represents available identity information scopes
    /// </summary>
    public enum IdentityScope
    {
        /// <summary>
        /// Windows credentials associated with the security context
        /// </summary>
        Windows,
        /// <summary>
        /// Primary identity credentials associated with the security context
        /// </summary>
        Primary,
        /// <summary>
        /// Thread's attached principal
        /// </summary>
        ThreadPrincipal,
        /// <summary>
        /// Client credentials as claimms associated with the security context
        /// </summary>
        ClaimSet
    }
}
