﻿using System;
using System.Collections.Generic;
using System.Text;
using System.ServiceModel.Description;

namespace WcfContrib.Metadata
{
    /// <summary>
    /// Represents a policy definition
    /// </summary>
    /// <typeparam name="T">The description type the policy is defined upon</typeparam>
    public class PolicyDefinition<T>
    {
        /// <summary>
        /// Gets the description the policy is defined upon
        /// </summary>
        public T Description { get; internal set; }

        /// <summary>
        /// Gets the policies defined with the specific description
        /// </summary>
        public PolicyAssertionCollection Policies { get; internal set; }

        /// <summary>
        /// Initializes a new instance of the <see cref="PolicyDefinition&lt;T&gt;"/> class.
        /// </summary>
        public PolicyDefinition()
        {

        }
    }
}
